package com.dsic.gj_erp.controller.jhgk;


import com.alibaba.excel.EasyExcel;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmYdjhxf;
import com.dsic.gj_erp.bean.jhgk.excel.SyExcel;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelSYListener;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdService;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@RestController
@RequestMapping("/dmSygd")
public class DmSygdController {

    @Resource
    DmSygdService service;
    @Resource
    DmSygdMxService mxService;

    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmSygd sygd){
        List<DmYdjhxf> list= mxService.tqSygd2(sygd.getBeginTime(),sygd.getEndTime(),sygd.getGdZt());
        return new ResultBean(list);
    }

    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadSy(@RequestParam("file") MultipartFile file , HttpServletRequest req) throws Exception, CustomException {

        ExcelSYListener objectListener = new ExcelSYListener();
        EasyExcel.read(file.getInputStream(), SyExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<SyExcel> objList = objectListener.getObjectList();
        service.uploadSy(objList,req);
        return new ResultBean();
    }

    //提交
    //审核
    //退回

    @ApiOperation(value = "批量提交/退回")
    @PostMapping("/tj")
    @AuthFunction
    @ResponseBody
    public ResultBean tj(String from,String to){
        mxService.tj(from,to);
        return new ResultBean();
    }

    @ApiOperation(value = "批量审核")
    @PostMapping(value = "/sh")
    public ResultBean sh(String from,String to) {
        mxService.sh(from,to);
        return new ResultBean();
    }


}

